//CTracker.c++
//Chris Bentzel
//Oct. 97

/***************************************************************************
 * 
 * Copyright 1997  by  the  Massachusetts Institute  of Technology.   All  
 * rights reserved.
 * 
 * Developed  by the Perceptual Computing Section 
 * at the Media Laboratory, MIT, Cambridge, Massachusetts.
 * 
 * Permission to use, copy,  or modify this software and  its documentation
 * for  educational  and  research purposes only and without fee  is hereby
 * granted, provided  that this copyright notice and the original authors's
 * names appear  on all copies and supporting documentation.  If individual
 * files are  separated from  this  distribution directory  structure, this
 * copyright notice must be included.  For any other uses of this software,
 * in original or  modified form, including but not limited to distribution
 * in whole or in  part, specific  prior permission  must be  obtained from
 * MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
 *   basis  of  a commercial  software  or  hardware product  without first
 * obtaining appropriate licenses  from MIT.  MIT. makes no representations
 * about the suitability of this  software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 * 
 **************************************************************************/



/////////////////////////////////////////////////////////////////
////
////   Includes and preprocessor stuff
////
/////////////////////////////////////////////////////////////////
#include "CTracker.h++"
#include "misc_functions.h++"
#include "pvm3.h"
#include "messageTags.h++"
#include "mytime.h++"
#include <errno.h>

extern CVisState* theCurrentState;
extern int visStateID;



/////////////////////////////////////////////////////////////////
////
////   gesture data
////
/////////////////////////////////////////////////////////////////
/*
static float uCross[7] = {.2347, .0077, .0243, .0091, .0734, -0.0109, -0.0035};
static float invCovCross[7][7] = {
  {    3942,    -479,     201,   -4394,     428,    -609,   -3668},
  {    -479,    8569,     636,   -3347,    1086,    8803,   -1438},
  {     201,     636,    2629,   -6970,     783,    -468,   -4388},
  {   -4394,   -3347,   -6970,   50868,   -3342,    6429,   17379},
  {     428,    1086,     783,   -3342,    8828,    3474,   16283},
  {    -609,    8803,    -468,    6429,    3474,   22908,   16392},
  {   -3668,   -1438,   -4388,   17379,   16283,   16392,   82087}};

static float uHalfCross[7] = {0.1207, 0.0046,-0.0005,-0.0019, 0.2463, 0.0231,-0.0041};
static float invCovHalfCross[7][7] = {
  {   92290, -193160,  -35400,  -58530,    2040, -196310,   -2090},
  { -193160,  603390,  122810,  159180,    1080,  374110,   21480},
  {  -35400,  122810,  136500,  -15340,    9040,   64440,   29950},
  {  -58530,  159180,  -15340,  426030,    8270,   71210,    -110},
  {    2040,   -1080,    9040,    8270,    2730,  -10650,    2410},
  { -196310,  374110,   64440,   71210,  -10650,  461440,    2080},
  {   -2090,   21480,   29950,    -110,    2410,    2080,   13350}};

static float uHanging[7] = {.2164, -.0213, -.0102, -.0042, .0504, -.0012, .0016};
static float invCovHanging[7][7] = {
  {    5400,    -800,    2100,  -12000,   14500,  -14200,  -39200},
  {    -800,   10300,   -4900,  -17800,   -4800,   41200,   33400},
  {    2100,   -4900,   18200,    3520,   11000,  -15300,   41400},
  {   -1200,  -17800,   35200,  159000,   -7500,  -42000,  183400},
  {   14500,   -4800,   11000,   -7500,   82300,  -43800, -116300},
  {  -14200,   41200,  -15300,  -42000,  -43800,  348300,  451400},
  {  -39200,   33400,   41400,  183400, -116300,  451400, 1147700}};

static float uHalfHanging[7] = {0.1163, 0.0191,-0.0152,-0.0008, 0.1752, 0.0141,-0.0037};
static float invCovHalfHanging[7][7] = {
  {   41800,  -93600,   -1800,  -53800,   23300,  -13900,  -20400},
  {  -93600,  444000,  207100, -480500,  -17000, -193900,  -14200},
  {   -1800,  207100,  368000, -891700,   42400,  -95600,  -32100},
  {  -53800, -480500, -891700, 2437300, -154100,  429700,  147100},
  {   23300,  -17000,   42400, -154100,   24000,  -46800,  -20400},
  {  -13900, -193900,  -95600,  429700,  -46800,  333900,   88100},
  {  -20400,  -14200,  -32100,  147100,  -20400,   88100,   37700}};
  
  */

static float uCross[7] = 
  { 2.6080771e-01,   4.3816215e-02,   3.9775764e-02,   7.0668266e-03,   7.6712095e-02,  -2.2012391e-02,  -1.1731320e-02};
static float invCovCross[7][7] = { 
  { 1.1890524e+04,   2.2544746e+03,  -8.8660223e+03,  -1.5565254e+04,   1.6614629e+04,   3.0629434e+04,  -8.7227281e+03},
  { 2.2544746e+03,   2.2457855e+04,   2.2538166e+03,  -1.0215287e+03,   1.4393715e+04,   1.0102177e+04,   4.1269180e+04},
  {-8.8660223e+03,   2.2538166e+03,   3.6323290e+04,  -6.6600311e+03,  -1.0089038e+04,  -4.5994415e+04,   5.7092440e+04},
  {-1.5565254e+04,  -1.0215287e+03,  -6.6600311e+03,   1.1334918e+05,   1.4222789e+03,  -5.0352779e+04,   6.9747300e+04},
  { 1.6614629e+04,   1.4393715e+04,  -1.0089038e+04,   1.4222789e+03,   4.4523256e+04,   4.8569667e+04,   3.8254776e+04},
  { 3.0629434e+04,   1.0102177e+04,  -4.5994415e+04,  -5.0352779e+04,   4.8569667e+04,   1.3773484e+05,  -8.4362400e+04},
  {-8.7227281e+03,   4.1269180e+04,   5.7092440e+04,   6.9747300e+04,   3.8254776e+04,  -8.4362400e+04,   3.2104717e+05 }};

static float uHalfCross[7] = 
  { 1.1245315e-01,   2.5255699e-03,  -1.3265142e-02,   4.4144626e-04,   2.5044694e-01,   1.5254175e-02,   2.9097509e-02};
static float invCovHalfCross[7][7] = { 
  { 9.1698178e+03,  -1.5641200e+04,   1.2121993e+04,   5.3510806e+03,   2.4679635e+03,  -3.2375665e+04,  -1.9025052e+03},
  {-1.5641200e+04,   1.6598024e+05,  -5.4124113e+03,   1.4043702e+05,  -6.9215875e+03,   5.7883070e+04,   2.2182026e+04},
  { 1.2121993e+04,  -5.4124113e+03,   4.3479690e+04,   3.8939420e+04,   3.3541161e+03,  -6.8270849e+04,   2.7168442e+02},
  { 5.3510806e+03,   1.4043702e+05,   3.8939420e+04,   4.1244014e+05,  -9.7715110e+03,   2.3562940e+04,   4.4850108e+03},
  { 2.4679635e+03,  -6.9215875e+03,   3.3541161e+03,  -9.7715110e+03,   2.0479199e+03,  -1.5596454e+04,  -2.1635016e+03},
  {-3.2375665e+04,   5.7883070e+04,  -6.8270849e+04,   2.3562940e+04,  -1.5596454e+04,   1.9429917e+05,   8.7937213e+03},
  {-1.9025052e+03,   2.2182026e+04,   2.7168442e+02,   4.4850108e+03,  -2.1635016e+03,   8.7937213e+03,   1.1359407e+04}};

static float uHanging[7] = 
  { 3.2320861e-01,   1.0792916e-02,   1.5456695e-02,  -1.3348728e-02,   4.6667972e-02,  -7.9366128e-03,   7.6940335e-04};
static float invCovHanging[7][7] = { 
  { 1.4901235e+03,  -1.4869363e+03,   3.3975422e+02,   2.2763612e+03,   4.1912207e+03,  -4.2920387e+03,   7.1545079e+03},
  {-1.4869363e+03,   6.0440790e+03,   3.0385253e+03,  -5.4567566e+03,  -1.4437152e+04,   7.5066787e+03,   4.6406790e+03},
  { 3.3975422e+02,   3.0385253e+03,   7.5216326e+03,  -8.5394550e+03,  -2.0285219e+03,   1.4627603e+04,   2.9435319e+04},
  { 2.2763612e+03,  -5.4567566e+03,  -8.5394550e+03,   3.3075815e+04,   3.1136882e+04,  -2.5942987e+04,   2.4755184e+04},
  { 4.1912207e+03,  -1.4437152e+04,  -2.0285219e+03,   3.1136882e+04,   1.1045224e+05,  -4.6066947e+03,   8.3393137e+04},
  {-4.2920387e+03,   7.5066787e+03,   1.4627603e+04,  -2.5942987e+04,  -4.6066947e+03,   7.7549495e+04,   2.2116881e+04},
  { 7.1545079e+03,   4.6406790e+03,   2.9435319e+04,   2.4755184e+04,   8.3393137e+04,   2.2116881e+04,   3.9264148e+05}};

static float uHalfHanging[7] = 
  { 1.6717322e-01,   3.6107742e-02,  -1.7338623e-02,  -2.3848722e-03,   1.3840734e-01,   1.7588292e-02,  -7.0546891e-03};
static float invCovHalfHanging[7][7] = { 
  { 5.3894946e+03,  -8.2822804e+03,   2.2773706e+02,  -5.2933520e+03,  -8.5703020e+02,  -1.9008784e+03,  -3.6115638e+03},
  {-8.2822804e+03,   2.4973853e+04,  -4.0071063e+03,   1.3334948e+04,   3.6219448e+03,  -1.1758792e+03,   6.3747435e+03},
  { 2.2773706e+02,  -4.0071063e+03,   2.2930816e+04,  -3.0892521e+04,  -6.9590847e+02,   3.7627172e+03,   9.3607225e+03},
  {-5.2933520e+03,   1.3334948e+04,  -3.0892521e+04,   8.5128348e+04,   1.6430833e+03,   4.1304598e+03,   8.5931545e+01},
  {-8.5703020e+02,   3.6219448e+03,  -6.9590847e+02,   1.6430833e+03,   1.7912638e+03,  -7.7047620e+02,   6.1947399e+02},
  {-1.9008784e+03,  -1.1758792e+03,   3.7627172e+03,   4.1304598e+03,  -7.7047620e+02,   2.5151830e+04,   5.8276360e+03},
  {-3.6115638e+03,   6.3747435e+03,   9.3607225e+03,   8.5931545e+01,   6.1947399e+02,   5.8276360e+03,   1.2697835e+04 }};


/////////////////////////////////////////////////////////////////
////
////   Constructor
////
/////////////////////////////////////////////////////////////////
CTracker::CTracker(trackInit& initialData)
{
  //Copy over the data passed to the Constructor
  width = initialData.imWidth;
  height = initialData.imHeight;
  minNumberOfPixels = initialData.minNumPixels;
  auxiliaryMinNumberOfPixels = initialData.auxMinNumPixels;
  maxAllowedError = initialData.maxError;
  depthFactor = initialData.depthFact;
  verbose = initialData.verboseFlag;
  niftyHacks = initialData.niftyHacksFlag;
  minCubePixels = initialData.minCubePixels;
 
  //Report that info if necessary
  if (verbose)
    {
      cerr << "\n\nWidth : " << width << endl;
      cerr << "Height : " << height << endl;
      cerr << "minNumberOfPixels : " << minNumberOfPixels << endl;
      cerr << "auxiliaryMinNumberOfPixels : " << auxiliaryMinNumberOfPixels << endl;
      cerr << "maxAllowedError : " << maxAllowedError << endl;
      cerr << "depthFactor : " << depthFactor << endl;
      cerr << "niftyHacks: " << niftyHacks << endl;
      cerr << "minCubePixels: " << minCubePixels << endl;
    }

  //Initialize the local images
  mostRecentImage.init(width, height);
  lastRecentImage.init(width, height);
  mostRecentImageSection.init(150, 150);
  blobMap.init(width, height);
  RGBIm.init(width, height);

  
  if (verbose)
    {
      cerr << "finished initializing images\n";
    }
  
  //Set the time stamp to the beginning
  timeStampValue = 0;
  lastIndex = -1;
  
  //Initialize the time-based arrays
  for (int i = 0; i < TRACKER_QUEUE_LENGTH; i++)
    {
      numberOfBlobs[i] = 0;
      numberOfPeople[i] = 1;
      for (int j = 0; j < NUMBER_OF_PEOPLE; j++)
        {
          personArrayCache[i][j] = new CPerson();
          humanBlobs[i][j] = new int[0];
        }
      for (j = 0; j < NUMBER_OF_CUBES; j++)
        {
          cubeArrayCache[i][j] = new CCube();
          cubeBlobs[i][j] = new int[0];
        }
      blobArrayCache[i] = NULL;
    }
  
  //Have no bounding box yet
  bboxSet = 0;
  
  //set up statistics gatherers
  gatherUpperHalfStats = 0;
  gatherWholeBodyStats = 0;
  
  //set up the detector states
  cubeDetectorNumber = theCurrentState->visStringToInt("track cubes");
  stopping1DetectorNumber = theCurrentState->visStringToInt("stopping1");
  stopping2DetectorNumber = theCurrentState->visStringToInt("stopping2");
  stopping3DetectorNumber = theCurrentState->visStringToInt("stopping3");
  upDetectorNumber = theCurrentState->visStringToInt("up");
  downDetectorNumber = theCurrentState->visStringToInt("down");
  reachingDetectorNumber = theCurrentState->visStringToInt("reaching");
  seatedDetectorNumber = theCurrentState->visStringToInt("seated");
  cerr << "seated detector number is " << seatedDetectorNumber << "\n";

  for (i = 0; i < TRACKER_QUEUE_LENGTH; i++)
    {
      //detect state
      cubeDetectorDetecting[i] = DETECTOR_NOT_DETECTING;
      stopping1DetectorDetecting[i] = DETECTOR_DETECTING;
      stopping2DetectorDetecting[i] = DETECTOR_DETECTING;
      stopping3DetectorDetecting[i] = DETECTOR_DETECTING;
      upDetectorDetecting[i] = DETECTOR_NOT_DETECTING;
      downDetectorDetecting[i] = DETECTOR_NOT_DETECTING;
      reachingDetectorDetecting[i] = DETECTOR_NOT_DETECTING;
      seatedDetectorDetecting[i] = DETECTOR_DETECTING;

      //event state
      stopping1DetectorEvent[i] = DETECTOR_NOT_EVENT;
      stopping2DetectorEvent[i] = DETECTOR_NOT_EVENT;
      stopping3DetectorEvent[i] = DETECTOR_NOT_EVENT;
      upDetectorEvent[i] = DETECTOR_NOT_EVENT;
      downDetectorEvent[i] = DETECTOR_NOT_EVENT;
      seatedDetectorEvent[i] = DETECTOR_NOT_EVENT;
    }

  cerr << "seatedDetectorDetecing[29] = " << seatedDetectorDetecting[29] << endl;

  pauseImage = 0;
  
  //set the hysterisisCounters to 0
  maxNumberOfPeopleHysteresisCount = 12;
  numberOfPeopleHysteresisCount = 0;
  maxSeatingHysteresisCount = 3;
  seatingHysteresisCount = 0;
  seatingHysteresisWacky = 0;
  crossHysteresisCountUp = 0;
  maxCrossHysteresisCountUp = 4;
  crossHysteresisCountDown = 0;
  maxCrossHysteresisCountDown = 6;
  hangingHysteresisCountUp = 0;
  maxHangingHysteresisCountUp = 3;
  hangingHysteresisCountDown = 0;
  maxHangingHysteresisCountDown = 6;
  
  //get seated detector state
  genericDetector = new CDetector();
  
  //initialize the display
  disp = new TDisplay(width, height, "blob-o-rama");
  
  if (verbose)
    {
      cerr << "Done constructing tracker.\n";
    }

  //mostRecentImage.readPGM("test.pgm");

}



/////////////////////////////////////////////////////////////////
////
////   Destructor
////
/////////////////////////////////////////////////////////////////
CTracker::~CTracker()
{
  
  //Get rid of all the blobs
  for (int i = 0; i < TRACKER_QUEUE_LENGTH; i++)
    for (int j = 0; j < numberOfBlobs[i]; j++)
      delete (blobArrayCache[i][j]);

  //get rid of the visStates
  for (i = 0; i < TRACKER_QUEUE_LENGTH; i++)
    {
      for (int j = 0; j < NUMBER_OF_PEOPLE; j++)
        {
          delete (personArrayCache[i][j]);
          delete[] (humanBlobs[i][j]);
        }
      
      for (j = 0; j < NUMBER_OF_CUBES; j++)
        {
          delete cubeArrayCache[i][j];
          delete[] cubeBlobs[i][j];
        }
      
    }
  
  //delete the person and detector
  //delete tmpPerson;
  delete genericDetector;

  //remove the display
  delete disp;
}



/////////////////////////////////////////////////////////////////
////
////   addNewImage
////
/////////////////////////////////////////////////////////////////
int
CTracker::addNewImage(GRAYimage& Im)
{
  long firstTime;
  //Get the time before calculating the image
  if (verbose)
    {
      firstTime = GetTimeNowMiliSeconds();
    }
  
  //calculate the index (is this where we want it)
  index = timeStampValue % TRACKER_QUEUE_LENGTH;

  //copy image over
  mostRecentImage = Im;

  //write the image to make sure
  //if (timeStampValue == 10)
  //  {
  //    mostRecentImage.writePGM("trackerImage.pgm");
  //  }

  if (verbose)
    {
      cerr << "index: " << index << endl;
      cerr << "about to dilate and process image\n";
    }

  //Perform pre-processing on the image
  dilate(mostRecentImage, 1, 4);
  //dilate(mostRecentImage, 0, 5);
  if (verbose)
    {
      cerr << "connectivity\n";
    }
  
  //Perform connectivity pass
  connectivityPass();

  if (verbose)
    {
      cerr << "extraction\n";
    }
  
  //record the valid blobs only  
  extractValidBlobs(); 

  if (verbose)
    {
      cerr << "prepare display\n";
    }

  //check to see if detectors are operating
  //for now, assume they always have default condition
  //since this is not exactly "working", punt it and assume detectors are on
  //checkDetectors();
  
  if (verbose)
    {
      cerr << "assigning blobs to human\n";
    }
  
  //sort the blobs out
  sortBlobsBySize();
  
  // prepare the output
  prepareDisplayImage();
  
  //try to find the human blobs
  assignBlobsToHuman();

  //check if crouched
  if (seatedDetectorDetecting[index] == DETECTOR_DETECTING)
    //if (1)
    {
      if (index == 29)
        {
          cerr << "calling isSitting for index 29\n";
        }
      
      isSitting();
    }
  else
    {
      cerr << "Not calling isSitting for index " << index << endl;
      //if we're not detecting, assume not sitting
      seatedDetectorEvent[index] = DETECTOR_NOT_EVENT;
    }
  
  if (timeStampValue > 0 || numberOfPeople[index] == 0)
    {
      calculateStoppingGestures();
    }
  
  //make the visState
  if (visStateID > 0)
    {
      if (verbose)
        {
          cerr << "setting visState\n";
        }
      
      setVisState();
    }
  
  //display the image
  if (!pauseImage)
    {
      disp->DrawFrame((unsigned long *)RGBIm.getData());
    }
  
  //clear values from last frame
  if (timeStampValue > 0)
    {
      stopping1DetectorEvent[lastIndex] = DETECTOR_NOT_EVENT;
      stopping2DetectorEvent[lastIndex] = DETECTOR_NOT_EVENT;
      seatedDetectorEvent[lastIndex] = DETECTOR_NOT_EVENT;
    }
  
  //increment the frame number
  timeStampValue++;
  
  //copy the old image to the new image
  lastRecentImage = mostRecentImage;
  
  lastIndex = index;
  
  //report the time to calculate this procedure
  if (verbose)
    {
      long secondTime = GetTimeNowMiliSeconds();
      cerr << "Time for blob: " << secondTime - firstTime << "\n\n";
    }
  
  //End the function
  return(0);
}



/////////////////////////////////////////////////////////////////
////
////   connectivityPass : do connectivity on image
////
/////////////////////////////////////////////////////////////////
void
CTracker::connectivityPass()
{
  long startConnectivityTime;
  startConnectivityTime = GetTimeNowMiliSeconds();

  //Reset the blob counters
  numberOfValidBlobs = 0;
  numberOfValidAndInvalidBlobs = 0;

  //Delete each of the old blobs
  for (int i = 0; i < numberOfBlobs[index]; i++)
    {
      if (verbose)
        {
          cerr << "deleting blob # " << i << endl;
        }
      delete blobArrayCache[index][i];
    }

  delete[] blobArrayCache[index];
  
  //label number: label to assign to new blob
  int labelNumber = 1;
  
  //clear the blobMap
  blobMap.clear();

  //for accessing the blobMap
  int lastRow;
  int lastColumn;
  
  //six-connectedness labels to use to determine blob connectivity
  int upLeftLabel = 0;
  int leftLabel = 0;
  int upLabel = 0;

  //just to make doubly sure
  currBlobArray = NULL;
  
  if (verbose)
    {
      cerr << "Connecting for frame : " << timeStampValue << endl << endl;
      //Sleep(400);
    }
  
  //Label the pixels: from Horn _Robot Vision_ page 69-70
  //For each pixel (non special-case)
  for (int thisRow = 1; thisRow < height; thisRow++)
    {
      lastRow = thisRow - 1;
      for (int thisColumn = 1; thisColumn < width; thisColumn++)
        {
          lastColumn = thisColumn-1;
          if (mostRecentImage.getPixel(thisColumn, thisRow) > 0)
            {
              //If pixel up and to the left is labeled
              upLeftLabel = blobMap.getPixel(lastColumn, lastRow);
              if (upLeftLabel > 0)
                {
                  //Add pixel to blob corresponding to label
                  currBlobArray[(upLeftLabel - 1)]->addPixel(thisColumn, thisRow);
                  //Label pixel the same way
                  blobMap.setPixel(thisColumn, thisRow, upLeftLabel);
                  //Go to next pixel
                }
              else
                {
                  //If pixel to left is labeled
                  leftLabel = blobMap.getPixel(lastColumn, thisRow);
                  if (leftLabel > 0)
                    {
                      //If pixel up not labeled
                      upLabel = blobMap.getPixel(thisColumn, lastRow);
                      if (upLabel <= 0)
                        {
                          //Add pixel to blob corresponding to left's label
                          currBlobArray[(leftLabel - 1)]->addPixel(thisColumn, thisRow);
                          //Label pixel the same way
                          blobMap.setPixel(thisColumn, thisRow, leftLabel);
                          //Go to next pixel
                        } //END left labeled, up not labeled
                      else
                        {
                          //If left's label equals up's label
                          if (leftLabel == upLabel)
                            {
                              //Add pixel to blob with that label
                              currBlobArray[(leftLabel-1)]->addPixel(thisColumn, thisRow);
                              //Label pixel the same way
                              blobMap.setPixel(thisColumn, thisRow, leftLabel);
                              //Go to next pixel
                            } //END left and up labeled the same
                          else
                            {
                              //Merge upper blob to left blob
                              currBlobArray[(leftLabel-1)]->mergeBlobs(currBlobArray[(upLabel-1)]);
                              //invalidate the other blob
                              currBlobArray[(upLabel-1)]->setValidBlob(INVALID_BLOB);
                              //change the count of valid blobs
                              numberOfValidBlobs--;
                              //Assign pixel to blob with left's label
                              currBlobArray[(leftLabel-1)]->addPixel(thisColumn, thisRow);
                              //Label pixel the same as left
                              blobMap.setPixel(thisColumn, thisRow, leftLabel);

                              //change the labeling on the last two rows of the blobMap
                              for (int col1 = 1; col1 < width; col1++)
                                {
                                  if (blobMap.getPixel(col1, thisRow - 1) == upLabel)
                                    {
                                      blobMap.setPixel(col1, thisRow - 1, leftLabel);
                                    }
                                }
                              for (int col2 = 1; col2 < thisColumn; col2++)
                                {
                                  if (blobMap.getPixel(col2, thisRow) == upLabel)
                                    {
                                      blobMap.setPixel(col2, thisRow, leftLabel);
                                    }
                                }
                            } //END left and up labeled differently
                        } //END left and up labeled
                    } //END left labeled
                  else
                    {
                      //If pixel up is labeled
                      upLabel = blobMap.getPixel(thisColumn, lastRow);
                      if (upLabel > 0)
                        {
                          //Add pixel to blob corresponding to up's label
                          currBlobArray[(upLabel-1)]->addPixel(thisColumn, thisRow);
                          //Label pixel the same way
                          blobMap.setPixel(thisColumn, thisRow, upLabel);
                          //Go to next pixel
                        } //END up labeled
                      else
                        {
                          int labelNumDecr = labelNumber - 1;

                          //create a temporary array
                          CBlob** tmpBlobArray = new CBlob*[labelNumber];
                          
                          //copy the pointer values over
                          if (labelNumber > 1)
                            {
                              memcpy(tmpBlobArray, currBlobArray, labelNumDecr*sizeof(CBlob *));
                            }
                          
                          //CBlob* tmpBlobHolder = new CBlob();
                          tmpBlobArray[labelNumDecr] = new CBlob();

                          //cerr << "the address is " << currBlobArray[labelNumDecr] << endl;
                          if (tmpBlobArray[labelNumDecr] == NULL)
                            {
                              cerr << "Unable to make CBlob: The memory is exhausted!\n";
                            }

                          //delete the old array
                          delete[] currBlobArray;
                          
                          //copy the value
                          currBlobArray = tmpBlobArray;
                          
                          //Add pixel to the new blob
                          currBlobArray[labelNumDecr]->addPixel(thisColumn, thisRow);
                          //Label pixel with the new label
                          blobMap.setPixel(thisColumn, thisRow, labelNumber);
                          //tell the blob that it has this label
                          currBlobArray[labelNumDecr]->addLabel(labelNumber);
                          
                          //increase the number of blobs in both counters
                          numberOfValidBlobs++;
                          numberOfValidAndInvalidBlobs++;
                          //increment the labelNumber
                          labelNumber++;
                          
                          //increment the number of blobs
                          numberOfBlobs[index] = numberOfBlobs[index] + 1;
                        } //END create new blob
                    }//END left not labeled
                } //END up and to the left not labeled
            } //END pixel = 0
        } //END of current row
    } //end image

  numberOfBlobs[index] = numberOfValidBlobs;

  if (verbose)
    {
      long endConnectivityTime;
      endConnectivityTime = GetTimeNowMiliSeconds();
      
      cerr << "Connectivity time: " << endConnectivityTime - startConnectivityTime << endl;
    }
}




/////////////////////////////////////////////////////////////////
////
////   extractValidBlobs()
////
/////////////////////////////////////////////////////////////////
void
CTracker::extractValidBlobs()
{
  long startExtractTime;
  startExtractTime = GetTimeNowMiliSeconds();

  
  //Create array of (valid) blobs for current frame
  blobArrayCache[index] = new pCBlob[numberOfValidBlobs];
   
  //Copy over the valid blobs
  int numberOfCopiedBlobs = 0;

  for (int i = 0; i < numberOfValidAndInvalidBlobs; i++)
    {
      if ((currBlobArray[i]->getValidBlob()) == VALID_BLOB)
        {
          //copy the blob over
          blobArrayCache[index][numberOfCopiedBlobs] = currBlobArray[i];
          
          //calculate the values
          blobArrayCache[index][numberOfCopiedBlobs]->calculateAll();
          
          //increment the numbers
          numberOfCopiedBlobs++;
        }
      else
        {
          delete currBlobArray[i];
        }
    }
  
  delete[] currBlobArray;
  
  if (verbose)
    {
      long finishExtractTime;
      finishExtractTime = GetTimeNowMiliSeconds();
      cerr << "Extraction time: " << finishExtractTime - startExtractTime << endl;
    }
}  



/////////////////////////////////////////////////////////////////
////
////   sortBlobsBySize()
////
/////////////////////////////////////////////////////////////////
void
CTracker::sortBlobsBySize()
{
  //initialize the order array
  if (numberOfValidBlobs > 0)
    {
      int* tmpOrderArray = new int[numberOfValidBlobs];
      int* sizeArray = new int[numberOfValidBlobs];
      for (int i = 0; i < numberOfValidBlobs; i++)
        {
          tmpOrderArray[i] = i;
          sizeArray[i] = blobArrayCache[index][i]->getNumberOfPixels();
        }
      
      //do a stupid bubble sort: generally not many blobs, so...
      for (i = 0; i < numberOfValidBlobs; i++)
        {
          int highestValue = -1;
          int highestIndex = -1;
          for (int j = i; j < numberOfValidBlobs; j++)
            {
              if (sizeArray[j] > highestValue)
                {
                  highestIndex = j;
                  highestValue = sizeArray[j];
                }
            }
          if (i != highestIndex)
            {
              int orderHolder = tmpOrderArray[i];
              int sizeHolder = sizeArray[i];
              tmpOrderArray[i] = tmpOrderArray[highestIndex];
              sizeArray[i] = highestValue;
              tmpOrderArray[highestIndex] = orderHolder;
              sizeArray[highestIndex] = sizeHolder;
            }
        }
      
      //done figuring order, now rearrange blobArray
      CBlob** sortBlobArray = new CBlob*[numberOfValidBlobs];
      for (i = 0; i < numberOfValidBlobs; i++)
        {
          sortBlobArray[i] = blobArrayCache[index][tmpOrderArray[i]];
        }
      
      //cerr << "Largest blob: " << sizeArray[0] << endl;
      
      //copy it over
      delete[] blobArrayCache[index];
      blobArrayCache[index] = sortBlobArray;
            
      //delete the temporary arrays
      delete[] tmpOrderArray;
      delete[] sizeArray;

    }
}



/////////////////////////////////////////////////////////////////
////
////   checkDetectors()
////
/////////////////////////////////////////////////////////////////
void
CTracker::checkDetectors()
{
  //well, reading the state _may_ be bad, but it will hopefully be fast enough

  theCurrentState->getDetector(cubeDetectorNumber, genericDetector);
  cubeDetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(stopping1DetectorNumber, genericDetector);
  stopping1DetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(stopping2DetectorNumber, genericDetector);
  stopping2DetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(stopping3DetectorNumber, genericDetector);
  stopping3DetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(upDetectorNumber, genericDetector);
  upDetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(downDetectorNumber, genericDetector);
  downDetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(reachingDetectorNumber, genericDetector);
  reachingDetectorDetecting[index] = genericDetector->getIsDetect();

  theCurrentState->getDetector(seatedDetectorNumber, genericDetector);
  //seatedDetectorDetecting[index] = genericDetector->getIsDetect();
}



/////////////////////////////////////////////////////////////////
////
////   toggleGatherUpperHalfStats()
////
/////////////////////////////////////////////////////////////////
void
CTracker::toggleGatherUpperHalfStats()
{
  if (gatherUpperHalfStats == 0)
    {
      cerr << "\n\nHalfStats\n\n";
      gatherUpperHalfStats = 1;
    }
  else
    {
      gatherUpperHalfStats = 0;
    }
}



/////////////////////////////////////////////////////////////////
////
////   toggleGatherWholeBodyStats()
////
/////////////////////////////////////////////////////////////////
void
CTracker::toggleGatherWholeBodyStats()
{
  if (gatherWholeBodyStats == 0)
    {
      cerr << "\n\nWholeStats\n\n";
      gatherWholeBodyStats = 1;
    }
  else
    {
      gatherWholeBodyStats = 0;
    }
}



/////////////////////////////////////////////////////////////////
////
////   assignBlobsToHuman()
////
/////////////////////////////////////////////////////////////////
void
CTracker::assignBlobsToHuman()
{
  //get the largest blob
  //int largestBlobSize = minNumberOfPixels;
  int i;
  
  //assum sorted
  int largestBlobIndex = -1;
  int iterIndex = 0;
  int noBlobBigEnough = 0;
  if (numberOfValidBlobs > 0)
    {
      while (largestBlobIndex < 0 && !noBlobBigEnough)
        {
          //see if greater than minimum size... if not, we have to quit (since sorted)
          if (blobArrayCache[index][iterIndex]->getNumberOfPixels() < minNumberOfPixels)
            {
              noBlobBigEnough = 1;
            }
          else
            {
              //make sure its not too high up
              float largeCentr[2];
              blobArrayCache[index][iterIndex]->getCentroid(largeCentr);
              //if it's down enough
              if (largeCentr[1] > 100)
                {
                  largestBlobIndex = iterIndex;
                }
              else
                {
                  iterIndex++;
                }
            }
        }
    }

  //if there is a large blob that fits our criteria
  if (largestBlobIndex > -1)
    {
      //reallocate the human blob arrays
      delete[] humanBlobs[index][0];
      numberOfHumanBlobs[index][0] = 1;
      humanBlobs[index][0] = new int[1];
      humanBlobs[index][0][0] = largestBlobIndex;
      
      //make a temporary value for easier code
      CBlob* largestBlob = blobArrayCache[index][largestBlobIndex];
      
      //tell the largest Blob it is part of a person (how sweet)
      largestBlob->setBlobType(PERSON_BLOB);
      
      //get the initial centroid of the human
      float tmpCentr[2];
      largestBlob->getCentroid(tmpCentr);
      
      if (verbose)
        {
          cerr << "tmpCentr: (" << tmpCentr[0] << "," << tmpCentr[1] << ")\n";
        }

      int tmpAuxiliaryMinNumberOfPixels;
      
      //if reaching, make the min number of pixels for sucked in blobs very small
      if (reachingDetectorDetecting[index] == DETECTOR_DETECTING)
        {
          tmpAuxiliaryMinNumberOfPixels = 20;
        }
      else
        {
          tmpAuxiliaryMinNumberOfPixels = auxiliaryMinNumberOfPixels;
        }
      
      //try to find other blobs close to that
      for (i = 0; i < numberOfBlobs[index]; i++)
        {
          if (i != largestBlobIndex)
            {
              CBlob* tmpBlob = blobArrayCache[index][i];
              //make sure the blob isn't just a small thing of noise

              
              if (niftyHacks)
                {
                  //cerr << "tmpCentr[0] " << tmpCentr[0] << endl;
                  //bad areas, make the maxAllowedError higher
                  if (tmpCentr[0] < 100 || tmpCentr[0] > 180)
                    {
                      tmpAuxiliaryMinNumberOfPixels = 20;
                    }
                  else
                    {
                      tmpAuxiliaryMinNumberOfPixels = auxiliaryMinNumberOfPixels;
                    }
                }

              if (tmpBlob->getNumberOfPixels() > auxiliaryMinNumberOfPixels)
                {
                  float tmpCentr2[2];
                  tmpBlob->getCentroid(tmpCentr2);
                  float delX = tmpCentr2[0] - tmpCentr[0];
                  float delY = tmpCentr2[1] - tmpCentr[1];
                  float errorThresh = 5*delX*delX + delY*delY;
                  
                  //if reaching, penalize upwards Y much less
                  if (reachingDetectorDetecting[index] == DETECTOR_DETECTING)
                    {
                      if (delY < 0)
                        {
                          errorThresh -= .9*delY*delY;
                        }
                    }

                  //grab the feet better
                  if (delY > 0)
                    {
                      errorThresh += .4*(delX*delX - delY*delY);
                    }

                  if (niftyHacks)
                    {
                      //cerr << "tmpCentr[0] " << tmpCentr[0] << endl;
                      //bad areas, make the maxAllowedError higher
                      if (tmpCentr[0] < 100 || tmpCentr[0] > 180)
                        {
                          //maxAllowedError += 500;
                          errorThresh += .8*delX*delX - .3*delY*delY ;
                        }
                    }
                  
                  //if the centroids are close enough, merge into the largest blob
                  if (errorThresh < maxAllowedError)
                    {
                      largestBlob->mergeBlobs(tmpBlob);
                      numberOfHumanBlobs[index][0] = numberOfHumanBlobs[index][0] + 1;
                      int* tmpArray = new int[numberOfHumanBlobs[index][0]];
                      memcpy(tmpArray, humanBlobs[index][0],
                             (numberOfHumanBlobs[index][0] - 1)*sizeof(int));
                      delete[] humanBlobs[index][0];
                      tmpArray[numberOfHumanBlobs[index][0] -1] = i;
                      humanBlobs[index][0] = tmpArray;
                      
                      tmpBlob->setValidBlob(INVALID_BLOB);
                      tmpBlob->setBlobType(PERSON_BLOB);
                    }
                }
            }
        }
      
      //recalculate the centroid, etc.
      largestBlob->calculateAll();
      
      //get the centroid again
      largestBlob->getCentroid(tmpCentr);
      
      //draw centroid
      drawCross(tmpCentr, 0);
      
      //place the centroid in memory
      humanImageCentroids[index][0][0] = tmpCentr[0];
      humanImageCentroids[index][0][1] = tmpCentr[1];
      
      int tmpBbox[4];
      largestBlob->getBoundingBox(tmpBbox);

      drawBBox(tmpBbox, 0);
      bboxSet = 1;
      
      //place the bounding box in memory
      memcpy(humanImageBBoxes[index][0], tmpBbox, sizeof(int)*4);

      //save the area
      humanImageArea[index][0] = largestBlob->getNumberOfPixels();
      
      //eigenStuff
      largestBlob->getEigenStuff(&(humanImageEigenStuff[index][0]));

      if (verbose)
        {
          cerr << "human orientation: " << humanImageEigenStuff[index][0].theta << endl;
        }
      
      //Jims Wierd Values
      largestBlob->getHuValues(&(humanImageHuValues[index][0]));

      if (gatherWholeBodyStats)
        {
          cerr
            << humanImageHuValues[index][0].h0 << " " 
            << humanImageHuValues[index][0].h1 << " "
            << humanImageHuValues[index][0].h2 << " "
            << humanImageHuValues[index][0].h3 << " "
            << humanImageHuValues[index][0].h4 << " "
            << humanImageHuValues[index][0].h5 << " "
            << humanImageHuValues[index][0].h6<< endl;
        }

      //convert to stage coordinates
      blobStage personCoords;
      imageToStage(tmpCentr, tmpBbox, &personCoords);
      
      CPerson* person = personArrayCache[index][0];

      //if its not the first frame, use the last couple frames
      if (timeStampValue > 0)
        {
          numberOfPeople[index] = hysteresis(1, numberOfPeople[lastIndex],
                                             numberOfPeopleHysteresisCount,
                                             maxNumberOfPeopleHysteresisCount);

          if (numberOfPeople[lastIndex] == 1)
            {
              CPerson* oldPerson = personArrayCache[lastIndex][0];
              
              //do something silly for display
              float* oldImageCentroid = humanImageCentroids[lastIndex][0];
              int* oldImageBBox = humanImageBBoxes[lastIndex][0];
              
              //drawCross(oldImageCentroid, 1);
              //drawBBox(oldImageBBox, 1);
              
              float lastBodyCentroid[3];
              float lastHeadCentroid[3];
              float lastWidth;
              
              oldPerson->getBodyCentroid(lastBodyCentroid);
              oldPerson->getHeadCentroid(lastHeadCentroid);
              lastWidth = oldPerson->getWidth();
              
              //perform a Kalman filter on the values
              float depthAlpha = .4;
              float xAlpha = .5;
              float alpha = .6;
              //personCoords.lowerCentroid[1] =
              //  personCoords.lowerCentroid[1]*alpha + (1 - alpha)*lastBodyCentroid[1];
              
              personCoords.upperCentroid[1] =
                personCoords.upperCentroid[1]*depthAlpha + (1 - depthAlpha)*lastHeadCentroid[1];
              
              personCoords.width =
                personCoords.width*alpha + (1 - alpha)*lastWidth;

              personCoords.upperCentroid[0] =
                personCoords.upperCentroid[0]*xAlpha + (1 - xAlpha)*lastHeadCentroid[0];
              
              if (verbose)
                {
                  //cerr << "lowerCentroid: (" << personCoords.lowerCentroid[0] << ","
                  //     << personCoords.lowerCentroid[1] << "," << personCoords.lowerCentroid[2]
                  //     << ")" << endl;
                  cerr << "upperCentroid: (" << personCoords.upperCentroid[0] << ","
                       << personCoords.upperCentroid[1] << "," << personCoords.upperCentroid[2]
                       << ")" << endl;
                      cerr << "width: " << personCoords.width << endl;
                }
            }
        }
      else
        {
          numberOfPeople[index] = 1;
        }
      
      person->setBodyCentroid(personCoords.upperCentroid);
      person->setHeadCentroid(personCoords.upperCentroid);
      person->setWidth(personCoords.width);

      //and calculate the half-body stats
      calcHalfBodyStats();
      if (gatherUpperHalfStats && !gatherWholeBodyStats)
        {
          cerr
            << halfHumanImageHuValues[index][0].h0 << " " 
            << halfHumanImageHuValues[index][0].h1 << " "
            << halfHumanImageHuValues[index][0].h2 << " "
            << halfHumanImageHuValues[index][0].h3 << " "
            << halfHumanImageHuValues[index][0].h4 << " "
            << halfHumanImageHuValues[index][0].h5 << " "
            << halfHumanImageHuValues[index][0].h6<< endl;
        }
    }
  //if there is no human
  else
    {
      //set the human blobs to -1 to indicate no person
      for (int i = 0; i < NUMBER_OF_PEOPLE; i++)
        {
          delete[] humanBlobs[index][i];
          numberOfHumanBlobs[index][i] = 0;
          humanBlobs[index][i] = new int[1];
          humanBlobs[index][i][0] = -1;
        }

      bboxSet = 0;
      //if this isn't the first frame
      if (timeStampValue > 0)
        {
          numberOfPeople[index] = hysteresis(0, numberOfPeople[lastIndex],
                                             numberOfPeopleHysteresisCount,
                                             maxNumberOfPeopleHysteresisCount);
          if (numberOfPeople[index] != 0)
            {
              if (niftyHacks)
                {
                  //copy over data from last frame
                  memcpy(humanImageCentroids[index][0],
                         humanImageCentroids[lastIndex][0],
                         sizeof(float)*2);
                  memcpy(humanImageBBoxes[index][0],
                         humanImageBBoxes[lastIndex][0],
                         sizeof(int)*4);
                  humanImageArea[index][0] = humanImageArea[lastIndex][0];
                  drawCross(humanImageCentroids[index][0], 0);
                  drawBBox(humanImageBBoxes[index][0], 0);
                }
            }
          else
            {
              if (niftyHacks)
                {
                  humanImageCentroids[index][0][0] =
                    humanImageCentroids[index][0][1] = 0;
                  humanImageBBoxes[index][0][0] =
                    humanImageBBoxes[index][0][1] = 1000;
                  humanImageBBoxes[index][0][2] =
                    humanImageBBoxes[index][0][3] = 0;
                  humanImageArea[index][0] = 0;
                }
            }          
        }
     //if this is the first frame, set to what we see
      else
        {
          numberOfPeople[index] = 0;
        }
    }
}




/////////////////////////////////////////////////////////////////
////
////   assignBlobsToCubes()
////
/////////////////////////////////////////////////////////////////
void
CTracker::assignBlobsToCubes()
{
  cerr << "\ncalling blobs to cubes for frame: "
       << timeStampValue << "\n";
  
  int i, j, k;
  //have the distances
  float* imCentDistance[NUMBER_OF_CUBES];

  //a more shorthand placeholder
  int currNumHumanBlobs = numberOfHumanBlobs[index][0];

  int* humanBlobList = humanBlobs[index][0];
  
  //calculate the distances from the other cubes
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      //initialize the array
      imCentDistance[i] = new float[numberOfBlobs[index]];
    }

  if (verbose)
    {
      cerr << "Initialized distance arrays for cubes\n";
    }

  //see if we can use old cube values or have to start from scratch
  int initializeCube[3] = {0, 0, 0};
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      //if the old centroid has a ridiculously high height, time to reinitialize
      if (cubeImageCentroids[lastIndex][i][1] < 70)
        {
          initializeCube[i] = 1;
        }
    }

  //since sorted, find which blob in blobArrayCache last possible to use
  int lastUsefulBlob = numberOfBlobs[index] - 1;
  int lastUsefulBlobStop = 0;
  i = 0;
  while (!lastUsefulBlobStop)
    {
      if (i < (numberOfBlobs[index] - 1))
        {
          if (blobArrayCache[index][i]->getNumberOfPixels() < minCubePixels)
            {
              lastUsefulBlob = i;
              lastUsefulBlobStop = 1;
            }
          i++;
        }
      else
        {
          lastUsefulBlobStop = 1;
        }
    }
  
  cerr << "numberOfBlobs is : " << numberOfBlobs[index] << endl;
  cerr << "lastUsefulBlob is : " << lastUsefulBlob << endl;

  //cerr << "finding distances\n";
  //for the cubes that are stable, find blob distances
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      //if we don't need to initialize
      if (!initializeCube[i])
        {

          //cerr << "cubeImageCentroids[" << lastIndex << "][" << i << "] = "
          //             << "(" << cubeImageCentroids[lastIndex][i][0] << ","
          //             << cubeImageCentroids[lastIndex][i][1] << ")\n";
       
          for (j = 0; j < lastUsefulBlob; j++)
            {
              //check to see if the blob is assigned to a human...
              int notAHumanBlob = 1;
              for (k = 0; k < currNumHumanBlobs; k++)
                {
                  if (humanBlobList[k] == j)
                    {
                      notAHumanBlob = 0;
                    }
                }

              //if its not, get a distance metric
              if (notAHumanBlob)
                {
                  //don't waste our time on tiny ass cubes (very tiny)
                  //if (blobArrayCache[index][j]->getNumberOfPixels() > minCubePixels)
                  //  {
                  //calculate the distance from the "cube blob" of the last frame.
                  float tmpCentr[2];
                  blobArrayCache[index][j]->getCentroid(tmpCentr);
                  //cerr << "tmpCentr = (" << tmpCentr[0] << "," << tmpCentr[1] << ")\n";
                  float deltaX = tmpCentr[0] - cubeImageCentroids[lastIndex][i][0];
                  float deltaY = tmpCentr[1] - cubeImageCentroids[lastIndex][i][1];
                  imCentDistance[i][j] = deltaX*deltaX + deltaY*deltaY;
                  //cerr << "imCentDistance[" << i << "][" << j << "] = "
                  //     << imCentDistance[i][j] << endl;
                  
                }
              //if its tiny, make the distance huge so we don't deal with it
              //    else
              //{
              //imCentDistance[i][j] = 1000000;
              //}
              //}
              //if its a human, set distance huge so we avoid it later
              else
                {
                  //set the distance to an impossibly large (negative) value
                  imCentDistance[i][j] = 1000000;
                }
            }
        }
      //if we need to initialize this cube, set all the blobs to have a high value
      //so it is avoided
      else
        {
          for (j = 0; j < lastUsefulBlob; j++)
            {
              imCentDistance[i][j] = 1000000;
            }
        }
    } //end finding distances

  //cerr << "deleting cube data\n";
  //clear Cube Blob data for the frame
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      delete[] cubeBlobs[index][i];
      numberOfCubeBlobs[index][i] = 0;
    }
  
  //assign blobs to cubes appropriately
  float minAcceptableDistance = 1000;
  //int firstBlobForCube[3] = {1, 1, 1};

  //cerr << "matching blobs with old positions of cubes\n";
  for (i = 0; i < lastUsefulBlob; i++)
    {
      float minDistance = 2000000.0;
      int minCube = -1;
      for (j = 0; j < NUMBER_OF_CUBES; j++)
        {
          if (imCentDistance[j][i] < minDistance)
            {
              minDistance = imCentDistance[j][i];
              minCube = j;
            }
        }
      
      //cerr << "minCube is " << minCube << endl;
          
      //if close enough, add to the cube list
      if (minDistance < minAcceptableDistance)
        {
          
          cerr << "assigning blob #" << i << " to cube #" << minCube << endl;
          //update the arrays by one
          numberOfCubeBlobs[index][minCube] = numberOfCubeBlobs[index][minCube] + 1;
          cerr << "numberOfCubeBlobs[" << index << "][" << minCube << "] = "
               << numberOfCubeBlobs[index][minCube] << endl;
          int* tmpCubeBlobArray = new int[(numberOfCubeBlobs[index][minCube])];
          //cerr << "allocated memory\n";
          memcpy(tmpCubeBlobArray, cubeBlobs[index][minCube],
                 (numberOfCubeBlobs[index][minCube] - 1)*sizeof(int));
          tmpCubeBlobArray[numberOfCubeBlobs[index][minCube] -1] = i;
          delete[] cubeBlobs[index][minCube];
          cubeBlobs[index][minCube] = tmpCubeBlobArray;
          blobArrayCache[index][i]->setBlobType(OBJECT_BLOB);
        }
    }

  //cerr << "calculating values for a cube\n";
  //if they were assigned, merge the blobs for a cube and calculate values
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      if (numberOfCubeBlobs[index][i] > 0)
        {
          cerr << "merging for cube " << i << endl;
          cerr << "cubeBlobs[" << index << "][" << i << "][0] ="
               << cubeBlobs[index][i][0] << endl;
          CBlob* mergeBlob = blobArrayCache[index][cubeBlobs[index][i][0]];
          for (j = 1; j < numberOfCubeBlobs[index][i]; j++)
            {
              cerr << "merging in blob #" << cubeBlobs[index][i][j] << endl;
              mergeBlob->mergeBlobs(blobArrayCache[index][cubeBlobs[index][i][j]]);
              blobArrayCache[index][cubeBlobs[index][i][j]]->setValidBlob(INVALID_BLOB);
            }
          mergeBlob->calculateAll();
          float tmpCubeCentr[2];
          mergeBlob->getCentroid(tmpCubeCentr);
          cerr << "centroid: (" << tmpCubeCentr[0] << "," << tmpCubeCentr[1] << ")" << endl;
          int tmpCubeBBox[4];
          mergeBlob->getBoundingBox(tmpCubeBBox);
          drawCross(tmpCubeCentr, 1);
          drawBBox(tmpCubeBBox, 1);
          memcpy(cubeImageBBoxes[index][i], tmpCubeBBox, sizeof(int)*4);
          memcpy(cubeImageCentroids[index][i], tmpCubeCentr, sizeof(float)*2);   
        }
    }

  /*
  cerr << "No blobs for a cube:\n";
  //if there are no blobs for a cube (and don't need to initialize)
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      //see if there is another cube close by: if so, this is it
      if (!initializeCube[i])
        {
          if (numberOfCubeBlobs[index][i] == 0)
            {
              for (j = 0; j < NUMBER_OF_CUBES; j++)
                {
                  if (j != i)
                    {
                    }
                }
            }
        }
    }
    */
  
  //  cerr << "made it to shitty approach\n";

#define SHITTY_APPROACH

#ifdef SHITTY_APPROACH
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      if (initializeCube[i])
        {
          cerr << "initializing cube " << i << endl;
          int doneAssigning = 0;
          j = 0;
          int whippity = -1;
          while (!doneAssigning && j < lastUsefulBlob)
            {
              
              int blobType = blobArrayCache[index][j]->getBlobType();
              if (blobType != OBJECT_BLOB && blobType != PERSON_BLOB)
                {
                  whippity = j;
                  doneAssigning = 1;
                }
              j++;
            }
          if (whippity >= 0)
            {
              j = whippity;
              numberOfCubeBlobs[index][i] = 1;
              cubeBlobs[index][i] = new int[1];
              cerr << "Wooha!\n";
              cubeBlobs[index][i][0] = j;
              CBlob* meBlob = blobArrayCache[index][j];
              float tmpCubeCentr[2];
              meBlob->getCentroid(tmpCubeCentr);
              int tmpCubeBBox[4];
              meBlob->getBoundingBox(tmpCubeBBox);
              drawCross(tmpCubeCentr, 1);
              drawBBox(tmpCubeBBox, 1);
              memcpy(cubeImageBBoxes[index][i], tmpCubeBBox, sizeof(int)*4);
              memcpy(cubeImageCentroids[index][i], tmpCubeCentr, sizeof(float)*2);
              meBlob->setBlobType(OBJECT_BLOB);
            }
        }
    }
#endif

  //final pass: update the states, image to stage, etc.
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      blobStage cubeCoord;
      imageToStage(cubeImageCentroids[index][i], cubeImageBBoxes[index][i], &cubeCoord);
      cubeArrayCache[index][i]->setCentroid(cubeCoord.upperCentroid);
      cubeArrayCache[index][i]->setHeight(cubeCoord.upperCentroid[2]);
      cubeArrayCache[index][i]->setWidth(cubeCoord.width);
      //cerr << "cube #" << i << " location : (" << cubeCoord.upperCentroid[0]
      //     << "," << cubeCoord.upperCentroid[1] << "," << cubeCoord.upperCentroid[2]
      //     << ")" << endl;
    }
  
  /*
  //if we need to initialize, assign large blobs to locations
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      if (initializeCube[i])
        {
          for (j = 0; j < lastUsefulBlob; j++)
            {
              //check to see if not assigned to cube or to human
            }
        }
    }
    */
  
  for (i = 0; i < NUMBER_OF_CUBES; i++)
    {
      delete[] imCentDistance[i];
    }

  cerr << "done with cubes\n";
}



/////////////////////////////////////////////////////////////////
////
////   setVisState()
////
/////////////////////////////////////////////////////////////////
void
CTracker::setVisState()
{
  //try to read and lock the state
  pvm_initsend(PvmDataDefault);
  pvm_send(visStateID, VISSTATE_READ_AND_LOCK_REQUEST_MSGTAG);
  pvm_recv(visStateID, VISSTATE_READ_AND_LOCK_REPLY_MSGTAG);
  int ret;
  pvm_upkint(&ret, 1, 1);
  
  if (ret == VIS_STATE_READ)
    {
      theCurrentState->pvmUnpack();
      
      //set the person and the cubes
      theCurrentState->setPerson(0, personArrayCache[index][0]);

      //if (cubeDetectorDetecting[index] == DETECTOR_DETECTING)
      //  {
      for (int i = 0; i < NUMBER_OF_CUBES; i++)
        {
          theCurrentState->setCube(i, cubeArrayCache[index][i]);
        }
      // }
      
      //set the number of people
      theCurrentState->setNumberOfPeople(numberOfPeople[index]);
      
      //Gestures
      if (stopping1DetectorDetecting[index])
        {
          theCurrentState->getDetector(stopping1DetectorNumber, genericDetector);
          genericDetector->setIsEvent(stopping1DetectorEvent[index]);
          theCurrentState->setDetector(stopping1DetectorNumber, genericDetector);
        }
      
      if (stopping2DetectorDetecting[index])
        {
          theCurrentState->getDetector(stopping2DetectorNumber, genericDetector);
          genericDetector->setIsEvent(stopping2DetectorEvent[index]);
          theCurrentState->setDetector(stopping2DetectorNumber, genericDetector);  
        }
      

      if (stopping3DetectorDetecting[index])
        {
          theCurrentState->getDetector(stopping3DetectorNumber, genericDetector);
          genericDetector->setIsEvent(stopping3DetectorEvent[index]);
          theCurrentState->setDetector(stopping3DetectorNumber, genericDetector);
        }

      if (upDetectorDetecting[index])
        {
          theCurrentState->getDetector(upDetectorNumber, genericDetector);
          genericDetector->setIsEvent(upDetectorEvent[index]);
          theCurrentState->setDetector(upDetectorNumber, genericDetector);
        }
      
      if (downDetectorDetecting[index])
        {
          theCurrentState->getDetector(downDetectorNumber, genericDetector);
          genericDetector->setIsEvent(downDetectorEvent[index]);
          theCurrentState->setDetector(downDetectorNumber, genericDetector);
        }

      if (seatedDetectorDetecting[index])
        {
          theCurrentState->getDetector(seatedDetectorNumber, genericDetector);
          genericDetector->setIsEvent(seatedDetectorEvent[index]);
          theCurrentState->setDetector(seatedDetectorNumber, genericDetector);
        }
      
      //send out the state
      int modifyWorked = 0;
      int modifyCounter = 1;
      pvm_initsend(PvmDataDefault);
      theCurrentState->pvmPack();
      //cerr << "sending modify\n";
      pvm_send(visStateID, VISSTATE_MODIFY_REQUEST_MSGTAG);
      //cerr << "sent modify\n";
      //make sure that we get it unlocked before leaving
      while (!modifyWorked)
        {
          //cerr << "trying to get a good modification.\n";
          pvm_recv(visStateID, VISSTATE_MODIFY_REPLY_MSGTAG);
          //cerr << "received a modify reply.\n";
          int ret;
          pvm_upkint(&ret, 1, 1);
          if (ret == VIS_STATE_MODIFIED)
            {
              modifyWorked = 1;
            }
          else
            {
              pvm_initsend(PvmDataDefault);
              theCurrentState->pvmPack();
              //cerr << "sending modify\n";
              pvm_send(visStateID, VISSTATE_MODIFY_REQUEST_MSGTAG);
              //cerr << "sent modify\n";
            }
          modifyCounter++;
        }
    }
}



/////////////////////////////////////////////////////////////////
////
////   sendImageSection
////
/////////////////////////////////////////////////////////////////
void
CTracker::sendImageSection()
{
  if (verbose)
    {
  cerr << "\nsendImageSection being called\n";
    }
  
  //counters
  int i, j;

  //make it all black
  for (i = 0; i < 150; i++)
    for (j = 0; j < 150; j++)
      mostRecentImageSection.setPixel(i, j, 0);

  if (verbose)
    {
      cerr << "\nMade the image turn black.\n";
    }

  //a little test
  int* llist;
  int numLabels;
  int* humanBlobIndex = humanBlobs[index][0];
  if (humanBlobIndex[0] >= 0)
    {
      CBlob* humanBlob = blobArrayCache[index][humanBlobIndex[0]];
      numLabels = humanBlob->getNumberOfLabels();
      llist = new int[numLabels];
      humanBlob->getLabelList(llist);
    }
  
  //if a bounding box exist
  if (bboxSet)
    {
      int* theBbox = humanImageBBoxes[index][0];
      //center the image
      int bboxWidth = theBbox[2] - theBbox[0];
      if (bboxWidth > 150)
        bboxWidth = 150;
      int bboxHeight = theBbox[3] - theBbox[1];
      if (bboxHeight > 150)
        bboxHeight = 150;
      int startingX = (int)((150 - bboxWidth)/2);
      int startingY = (int)((150 - bboxHeight)/2);

      if (verbose)
        {
          cerr << "\nGot bounding box and starting coordinates.\n";
        }
      
      //place the white points
      for (i = 0; i < bboxWidth; i++)
        for (j = 0; j < bboxHeight; j++)
          {
            int pixelVal = blobMap.getPixel((theBbox[0] + i), (theBbox[1] + j));
            int goodBlob = 0;
            for (int k = 0; k < numLabels; k++)
              {
                if (pixelVal == llist[k])
                  {
                    goodBlob = 1;
                  }
              }
            
            if (goodBlob)
              {
                mostRecentImageSection.setPixel((startingX + i), (startingY + j), 250);
              }
            else
              {
                 mostRecentImageSection.setPixel((startingX + i), (startingY + j), 0);
              }
          }
      
      //write it out, just like your mama
      delete[] llist;

      //pack it up, I'll take it
      mostRecentImageSection.PVMpack();
      
    }
   else
    {	
      //just send an empty image
      mostRecentImageSection.PVMpack();
    }
}



/////////////////////////////////////////////////////////////////
////
////   drawCross
////
/////////////////////////////////////////////////////////////////
void
CTracker::drawCross(float* centroid, int crossType)
{
  if (crossType == 0)
    {
      for (int i = -5; i <= 5; i++)
        {
          RGBIm.setGreen(centroid[0]+i, centroid[1], 0);
          RGBIm.setBlue(centroid[0]+i, centroid[1], 0);
          RGBIm.setRed(centroid[0]+i, centroid[1], 255);
          RGBIm.setGreen(centroid[0], centroid[1]+i, 0);
          RGBIm.setBlue(centroid[0], centroid[1]+i, 0);
          RGBIm.setRed(centroid[0], centroid[1]+i, 255);
        }
    }
  if (crossType == 1)
    {
      for (int i = -10; i <= 10; i++)
        {
          RGBIm.setGreen(centroid[0]+i, centroid[1], 255);
          RGBIm.setBlue(centroid[0]+i, centroid[1], 0);
          RGBIm.setRed(centroid[0]+i, centroid[1], 0);
          RGBIm.setGreen(centroid[0], centroid[1]+i, 255);
          RGBIm.setBlue(centroid[0], centroid[1]+i, 0);
          RGBIm.setRed(centroid[0], centroid[1]+i, 0);
        }
    }
  if (crossType == 2)
    {
      for (int i = -10; i <= 10; i++)
        {
          RGBIm.setGreen(centroid[0]+i, centroid[1], 255);
          RGBIm.setBlue(centroid[0]+i, centroid[1], 255);
          RGBIm.setRed(centroid[0]+i, centroid[1], 0);
          RGBIm.setGreen(centroid[0], centroid[1]+i, 255);
          RGBIm.setBlue(centroid[0], centroid[1]+i, 255);
          RGBIm.setRed(centroid[0], centroid[1]+i, 0);
        }
    }

} 



/////////////////////////////////////////////////////////////////
////
////   drawBBox
////
/////////////////////////////////////////////////////////////////
void
CTracker::drawBBox(int* bbox, int bboxType)
{
  if (bboxType == 0)
    {
      for (int bboxop = bbox[0]; bboxop <= bbox[2]; bboxop++)
        {
          RGBIm.setBlue(bboxop, bbox[1], 0);
          RGBIm.setGreen(bboxop, bbox[1], 0);
          RGBIm.setRed(bboxop, bbox[1], 255);
          RGBIm.setBlue(bboxop, bbox[1]-1, 0);
          RGBIm.setGreen(bboxop, bbox[1]-1, 0);
          RGBIm.setRed(bboxop, bbox[1]-1, 255);
          RGBIm.setBlue(bboxop, bbox[3], 0);
          RGBIm.setGreen(bboxop, bbox[3], 0);
          RGBIm.setRed(bboxop, bbox[3], 255);
          RGBIm.setBlue(bboxop, bbox[3]+1, 0);
          RGBIm.setGreen(bboxop, bbox[3]+1, 0);
          RGBIm.setRed(bboxop, bbox[3]+1, 255);
        }
      for (int bboxSide = bbox[1]; bboxSide <= bbox[3]; bboxSide++)
        {
          RGBIm.setBlue(bbox[0], bboxSide, 0);
          RGBIm.setGreen(bbox[0], bboxSide, 0);
          RGBIm.setRed(bbox[0], bboxSide, 255);
          RGBIm.setBlue(bbox[0]-1, bboxSide, 0);
          RGBIm.setGreen(bbox[0]-1, bboxSide, 0);
          RGBIm.setRed(bbox[0]-1, bboxSide, 255);
          RGBIm.setBlue(bbox[2], bboxSide, 0);
          RGBIm.setGreen(bbox[2], bboxSide, 0);
          RGBIm.setRed(bbox[2], bboxSide, 255);
          RGBIm.setBlue(bbox[2]+1, bboxSide, 0);
          RGBIm.setGreen(bbox[2]+1, bboxSide, 0);
          RGBIm.setRed(bbox[2]+1, bboxSide, 255);
        }
      bboxSet = 1;
    }
  if (bboxType == 1)
    {
      for (int bboxop = bbox[0]; bboxop <= bbox[2]; bboxop++)
        {
          RGBIm.setBlue(bboxop, bbox[1], 0);
          RGBIm.setGreen(bboxop, bbox[1], 255);
          RGBIm.setRed(bboxop, bbox[1], 0);
          RGBIm.setBlue(bboxop, bbox[1]-1, 0);
          RGBIm.setGreen(bboxop, bbox[1]-1, 255);
          RGBIm.setRed(bboxop, bbox[1]-1, 0);
          RGBIm.setBlue(bboxop, bbox[3], 0);
          RGBIm.setGreen(bboxop, bbox[3], 255);
          RGBIm.setRed(bboxop, bbox[3], 0);
          RGBIm.setBlue(bboxop, bbox[3]+1, 0);
          RGBIm.setGreen(bboxop, bbox[3]+1, 255);
          RGBIm.setRed(bboxop, bbox[3]+1, 0);
        }
      for (int bboxSide = bbox[1]; bboxSide <= bbox[3]; bboxSide++)
        {
          RGBIm.setBlue(bbox[0], bboxSide, 0);
          RGBIm.setGreen(bbox[0], bboxSide, 255);
          RGBIm.setRed(bbox[0], bboxSide, 0);
          RGBIm.setBlue(bbox[0]-1, bboxSide, 0);
          RGBIm.setGreen(bbox[0]-1, bboxSide, 255);
          RGBIm.setRed(bbox[0]-1, bboxSide, 0);
          RGBIm.setBlue(bbox[2], bboxSide, 0);
          RGBIm.setGreen(bbox[2], bboxSide, 255);
          RGBIm.setRed(bbox[2], bboxSide, 0);
          RGBIm.setBlue(bbox[2]+1, bboxSide, 0);
          RGBIm.setGreen(bbox[2]+1, bboxSide, 255);
          RGBIm.setRed(bbox[2]+1, bboxSide, 0);
        }
      bboxSet = 1;
    }
  if (bboxType == 2)
    {
      for (int bboxop = bbox[0]; bboxop <= bbox[2]; bboxop++)
        {
          RGBIm.setBlue(bboxop, bbox[1], 255);
          RGBIm.setGreen(bboxop, bbox[1], 255);
          RGBIm.setRed(bboxop, bbox[1], 0);
          RGBIm.setBlue(bboxop, bbox[1]-1, 255);
          RGBIm.setGreen(bboxop, bbox[1]-1, 255);
          RGBIm.setRed(bboxop, bbox[1]-1, 0);
          RGBIm.setBlue(bboxop, bbox[3], 255);
          RGBIm.setGreen(bboxop, bbox[3], 255);
          RGBIm.setRed(bboxop, bbox[3], 0);
          RGBIm.setBlue(bboxop, bbox[3]+1, 255);
          RGBIm.setGreen(bboxop, bbox[3]+1, 255);
          RGBIm.setRed(bboxop, bbox[3]+1, 0);
        }
      for (int bboxSide = bbox[1]; bboxSide <= bbox[3]; bboxSide++)
        {
          RGBIm.setBlue(bbox[0], bboxSide, 255);
          RGBIm.setGreen(bbox[0], bboxSide, 255);
          RGBIm.setRed(bbox[0], bboxSide, 0);
          RGBIm.setBlue(bbox[0]-1, bboxSide, 255);
          RGBIm.setGreen(bbox[0]-1, bboxSide, 255);
          RGBIm.setRed(bbox[0]-1, bboxSide, 0);
          RGBIm.setBlue(bbox[2], bboxSide, 255);
          RGBIm.setGreen(bbox[2], bboxSide, 255);
          RGBIm.setRed(bbox[2], bboxSide, 0);
          RGBIm.setBlue(bbox[2]+1, bboxSide, 255);
          RGBIm.setGreen(bbox[2]+1, bboxSide, 255);
          RGBIm.setRed(bbox[2]+1, bboxSide, 0);
        }
      bboxSet = 1;
    }
  
}


/////////////////////////////////////////////////////////////////
////
////   imageToStage
////
/////////////////////////////////////////////////////////////////
void
CTracker::imageToStage(float* blobCentroid, int* boundingBox, blobStage* blobCoord)
{
  float tmpCentroid[3];
  
  //calculate depth first
  tmpCentroid[1] = ((float)(depthFactor*(height - boundingBox[3] - 10)))/((float)(height));
  float delDepth = tmpCentroid[1] - .5;
  delDepth *= 1.4;
  tmpCentroid[1] = .5+delDepth;
  
  if (tmpCentroid[1] > 1)
    tmpCentroid[1] = 1;
  if (tmpCentroid[1] < 0)
    tmpCentroid[1] = 0;

  //get initial guess for x
  tmpCentroid[0] = ((float)(2*blobCentroid[0])/(float)(width)) - 1.1;
  
  //makes x have a perspective effect
  //the 3 in the term is a constant that needs to be tested with calibration
  tmpCentroid[0] = tmpCentroid[0]*(1 + tmpCentroid[1]/3);

  //get width and height
  int pixelWidth = boundingBox[2] - boundingBox[0];
  int pixelHeight = boundingBox[3] - boundingBox[1];

  //need to make this inversely proportional to depth: or 1 - depth
  float heightDivisor = 1 - .5*(tmpCentroid[1]);
  float realHeight = ((float)(pixelHeight))/((float)(height*heightDivisor));
  tmpCentroid[2] = realHeight/2;

  memcpy(blobCoord->lowerCentroid, tmpCentroid, 3*sizeof(float));
 
  tmpCentroid[2] = realHeight;

  memcpy(blobCoord->upperCentroid, tmpCentroid, 3*sizeof(float));
  
  float realWidth = ((float)(2*pixelWidth))/((float)(width));
  blobCoord->width = realWidth;
}


/////////////////////////////////////////////////////////////////
////
////   isSitting
////
/////////////////////////////////////////////////////////////////
void
CTracker::isSitting()
{
  if (timeStampValue > 0)
    {
      //if we just turned on the detector, clear the values
      /*
        if (seatedDetectorDetecting[lastIndex] == DETECTOR_NOT_DETECTING)
        {
        seatingHysteresisCount = 0;
        seatingHysteresisWacky = 1;
        
      //assume not sitting
      for (int i = 0; i < TRACKER_QUEUE_LENGTH; i++)
      {
      seatedDetectorEvent[i] = DETECTOR_NOT_EVENT;
      }
      }
      */
      
      //get precalculated values
      float* personCentroid = humanImageCentroids[index][0];
      int* personBBox = humanImageBBoxes[index][0];
      
      //derive some metrics
      int bboxHeight = personBBox[3] - personBBox[1];
      int bboxWidth = personBBox[2] - personBBox[0];
      float bboxRatio = ((float)bboxHeight/bboxWidth);
      
      //get the difference in centroids
      float* oldPersonCentroid = humanImageCentroids[lastIndex][0];
      
      int personSize = humanImageArea[index][0];
      
      //go off of delX... depth not stable with leg problem
      float delX = oldPersonCentroid[0] - personCentroid[0];
      if (delX < 0)
        {
          delX = -delX;
        }
      
      eigenStuff currEigenStuff = humanImageEigenStuff[index][0];
      float eigenRatio = currEigenStuff.lambda1/currEigenStuff.lambda2;

      /*
      cerr << "eigenRatio: " << eigenRatio << endl;
      cerr << "bboxRatio: " << bboxRatio << endl;
      cerr << "delX: " << delX << endl;
      cerr << "personSize: " << personSize << endl;
      */
      
      //classify based on metrics
      //for josh, might need lower bbox ratio
      if (bboxRatio < 2.40 && delX < 6 && personSize < 2800 )
        {
          seatedDetectorEvent[index] = hysteresis(DETECTOR_EVENT,
                                                  seatedDetectorEvent[lastIndex],
                                                  seatingHysteresisCount,
                                                  maxSeatingHysteresisCount);
        }
      else
    {
      seatedDetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                              seatedDetectorEvent[lastIndex],
                                              seatingHysteresisCount,
                                              maxSeatingHysteresisCount);
    }
      
      cerr << "seating[" << index << "]: " << seatedDetectorEvent[index] << endl;
    }
}



/////////////////////////////////////////////////////////////////
////
////   prepareDisplayImage()
////
/////////////////////////////////////////////////////////////////
void
CTracker::prepareDisplayImage()
{
  int i, j;
  long startPrepareTime;
  startPrepareTime = GetTimeNowMiliSeconds();

  int gvalue;
  RGBIm.clear();
  
  for (i = 0; i < width; i++)
    for (j = 0; j < height; j++)
      {
        if ((gvalue = blobMap.getPixel(i, j)) > 0)
          {
            RGBIm.setRed(i, j, 180);
            RGBIm.setGreen(i, j, 180);
            RGBIm.setBlue(i, j, 180);
          }
      }

  if (verbose)
    {
      long finishPrepareTime;
      finishPrepareTime = GetTimeNowMiliSeconds();
      cerr << "Prepare time: " << finishPrepareTime - startPrepareTime << endl;
    }
}



/////////////////////////////////////////////////////////////////
////
////   hysteresis()
////
/////////////////////////////////////////////////////////////////
int
CTracker::hysteresis(int newValue, int oldValue, int& currCount, int maxCount)
{
  int retValue;
  
  if (newValue != oldValue)
    {
      currCount = (currCount + 1) % maxCount;
      if (currCount == 0)
        {
          retValue = newValue;
        }
      else
        {
          retValue = oldValue;
        }
    }
  else
    {
      currCount = 0;
      retValue = newValue;
    }
  return retValue;
}



/////////////////////////////////////////////////////////////////
////
////   malhanobisDistance()
////
/////////////////////////////////////////////////////////////////
float
CTracker::malhanobisDistance(float* data, float* mean, float** invCov, int numFeatures)
{
  int i, j;
  float* dataMinusMu = new float[numFeatures];
  
  for (i = 0; i < numFeatures; i++)
    {
      dataMinusMu[i] = data[i] - mean[i];
    }

  float* rightVect = new float[numFeatures];

  for (i = 0; i < numFeatures; i++)
    {
      rightVect[i] = 0;
      for (j = 0; j < numFeatures; j++)
        {
          rightVect[i] += invCov[i][j] * dataMinusMu[j];
        }
    }

  float retValue = 0.0;
  
  for (i = 0; i < numFeatures; i++)
    {
      retValue += dataMinusMu[i] * rightVect[i];  
    }

  delete[] dataMinusMu;
  delete[] rightVect;
  
  return retValue;
}



float
CTracker::malhanobisDistance(int whichTest)
{
  int i, j;

  float currHuValues[7];
  switch (whichTest) {
  case 0:
    currHuValues[0] = humanImageHuValues[index][0].h0;
    currHuValues[1] = humanImageHuValues[index][0].h1;
    currHuValues[2] = humanImageHuValues[index][0].h2;
    currHuValues[3] = humanImageHuValues[index][0].h3;
    currHuValues[4] = humanImageHuValues[index][0].h4;
    currHuValues[5] = humanImageHuValues[index][0].h5;
    currHuValues[6] = humanImageHuValues[index][0].h6;
    break;
  case 1:
    currHuValues[0] = humanImageHuValues[index][0].h0;
    currHuValues[1] = humanImageHuValues[index][0].h1;
    currHuValues[2] = humanImageHuValues[index][0].h2;
    currHuValues[3] = humanImageHuValues[index][0].h3;
    currHuValues[4] = humanImageHuValues[index][0].h4;
    currHuValues[5] = humanImageHuValues[index][0].h5;
    currHuValues[6] = humanImageHuValues[index][0].h6;
    break;
  case 2:
    currHuValues[0] = halfHumanImageHuValues[index][0].h0;
    currHuValues[1] = halfHumanImageHuValues[index][0].h1;
    currHuValues[2] = halfHumanImageHuValues[index][0].h2;
    currHuValues[3] = halfHumanImageHuValues[index][0].h3;
    currHuValues[4] = halfHumanImageHuValues[index][0].h4;
    currHuValues[5] = halfHumanImageHuValues[index][0].h5;
    currHuValues[6] = halfHumanImageHuValues[index][0].h6;
    break;
  case 3:
    currHuValues[0] = halfHumanImageHuValues[index][0].h0;
    currHuValues[1] = halfHumanImageHuValues[index][0].h1;
    currHuValues[2] = halfHumanImageHuValues[index][0].h2;
    currHuValues[3] = halfHumanImageHuValues[index][0].h3;
    currHuValues[4] = halfHumanImageHuValues[index][0].h4;
    currHuValues[5] = halfHumanImageHuValues[index][0].h5;
    currHuValues[6] = halfHumanImageHuValues[index][0].h6;
    break;
  case 4:
    currHuValues[0] = humanImageHuValues[index][0].h0;
    currHuValues[1] = humanImageHuValues[index][0].h1;
    currHuValues[2] = humanImageHuValues[index][0].h2;
    currHuValues[3] = humanImageHuValues[index][0].h3;
    currHuValues[4] = humanImageHuValues[index][0].h4;
    currHuValues[5] = humanImageHuValues[index][0].h5;
    currHuValues[6] = humanImageHuValues[index][0].h6;
    break;
  case 5:
    currHuValues[0] = humanImageHuValues[index][0].h0;
    currHuValues[1] = humanImageHuValues[index][0].h1;
    currHuValues[2] = humanImageHuValues[index][0].h2;
    currHuValues[3] = humanImageHuValues[index][0].h3;
    currHuValues[4] = humanImageHuValues[index][0].h4;
    currHuValues[5] = humanImageHuValues[index][0].h5;
    currHuValues[6] = humanImageHuValues[index][0].h6;
    break;
  }
  
  float* uVec;
  switch (whichTest) {
  case 0:
    uVec = uCross;
    break;
  case 1:
    uVec = uHanging;
    break;
  case 2:
    uVec = uHalfCross;
    break;
  case 3:
    uVec = uHalfHanging;
    break;
  case 4:
    uVec = uHalfCross;
    break;
  case 5:
    uVec = uHalfHanging;
  }

  float dataMinusMu[7];

  for (i = 0; i < 7; i++)
    {
      dataMinusMu[i] = currHuValues[i] - uVec[i];
    }

  float rightVect[7];

  switch (whichTest) {
  case 0:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovCross[i][j] * dataMinusMu[j];
          }
      }
    break;
  case 1:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovHanging[i][j] * dataMinusMu[j];
          }
      }
    break;
  case 2:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovHalfCross[i][j] * dataMinusMu[j];
          }
      }
    break;
  case 3:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovHalfHanging[i][j] * dataMinusMu[j];
          }
      }
    break;
  case 4:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovHalfCross[i][j] * dataMinusMu[j];
          }
      }
    break;
  case 5:
    for (i = 0; i < 7; i++)
      {
        rightVect[i] = 0;
        for (j = 0; j < 7; j++)
          {
            rightVect[i] += invCovHalfHanging[i][j] * dataMinusMu[j];
          }
      }
    break;
  }
  
  float retValue = 0.0;
  
  for (i = 0; i < 7; i++)
    {
      retValue += dataMinusMu[i] * rightVect[i];  
    }

  return retValue;
}



/////////////////////////////////////////////////////////////////
////
////   calculateGestures()
////
/////////////////////////////////////////////////////////////////
void
CTracker::calculateStoppingGestures()
{
  if (timeStampValue > 0)
    {
      cerr << "numberOfPeople[index] : " << numberOfPeople[index] << endl;
      cerr << "numberOfPeople[lastIndex] : " << numberOfPeople[lastIndex] << endl;
      
      float* personCentroid = humanImageCentroids[index][0];
      float* oldPersonCentroid = humanImageCentroids[lastIndex][0];
      
      //go off of delX... depth not stable with leg problem
      float delX = oldPersonCentroid[0] - personCentroid[0];
      if (delX < 0)
        {
          delX = -delX;
        }
      
      
      float crossResult = malhanobisDistance(0);
      float hangingResult = malhanobisDistance(1);
      float halfCrossResult = malhanobisDistance(2);
      float halfHangingResult = malhanobisDistance(3);
      
      //the following two don't look particularly useful
      /*
        float whole2HalfCrossResult = malhanobisDistance(4);
        float whole2HalfHangingResult = malhanobisDistance(5);
        */
      
     
        cerr << "crossResult: " << crossResult << endl;
        cerr << "halfCrossResult: " << halfCrossResult << endl;
        cerr << "hangingResult: " << hangingResult << endl;
        cerr << "halfHangingResult: " << halfHangingResult << endl;
        
      
      /*
        cerr << "whole2HalfCrossResult: " << whole2HalfCrossResult << endl;
        cerr << "whole2HalfHangingResult: " << whole2HalfHangingResult << endl;
        */
      
      //see if the person is in the right area of the stage and is not moving
        if (delX < 5)  // && (personCentroid[0] < 100 || personCentroid[0] > 180))
          {
            
            if (hangingResult < 10 || halfHangingResult < 22)
              {
                stopping2DetectorEvent[index] = hysteresis(DETECTOR_EVENT,
                                                           stopping2DetectorEvent[lastIndex],
                                                           hangingHysteresisCountUp,
                                                           maxHangingHysteresisCountUp);

                stopping1DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                           stopping1DetectorEvent[lastIndex],
                                                           crossHysteresisCountDown,
                                                           maxHangingHysteresisCountDown);
              }
            
            else
              {
              //check for cross
                if (crossResult < 12 || halfCrossResult < 30)
                  {
                    
                    stopping1DetectorEvent[index] = hysteresis(DETECTOR_EVENT,
                                                               stopping1DetectorEvent[lastIndex],
                                                               crossHysteresisCountUp,
                                                               maxCrossHysteresisCountUp);

                    stopping2DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                               stopping2DetectorEvent[lastIndex],
                                                               hangingHysteresisCountUp,
                                                               maxHangingHysteresisCountUp);
                  }
                
                //
              else
                {
                  stopping1DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                             stopping1DetectorEvent[lastIndex],
                                                             crossHysteresisCountDown,
                                                             maxCrossHysteresisCountDown);
                  
                  stopping2DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                             stopping2DetectorEvent[lastIndex],
                                                             hangingHysteresisCountDown,
                                                             maxHangingHysteresisCountDown);
                }
              }
          }
        
        //if the person is moving or in the wrong position, try to say that the event is not happening.
        else
          {
            stopping1DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                       stopping1DetectorEvent[lastIndex],
                                                       crossHysteresisCountDown,
                                                       maxCrossHysteresisCountDown);
            
            stopping2DetectorEvent[index] = hysteresis(DETECTOR_NOT_EVENT,
                                                       stopping2DetectorEvent[lastIndex],
                                                       hangingHysteresisCountDown,
                                                       maxHangingHysteresisCountDown);
          }
        
        cerr << "stopping1: " << stopping1DetectorEvent[index] << endl;
        cerr << "stopping2: " << stopping2DetectorEvent[index] << endl << endl;
        if (stopping1DetectorEvent[index] == DETECTOR_EVENT)
          {
            drawCross(humanImageCentroids[index][0], 1);
            drawBBox(humanImageBBoxes[index][0], 1);
          }
        else
          {
            for (int i = 0; i < TRACKER_QUEUE_LENGTH; i++)
              {
                stopping1DetectorEvent[index] = DETECTOR_NOT_EVENT;
              }
          }
        
        if (stopping2DetectorEvent[index] == DETECTOR_EVENT)
          {
            drawCross(humanImageCentroids[index][0], 2);
            drawBBox(humanImageBBoxes[index][0], 2);
          }
        else
          {
            for (int i = 0; i < TRACKER_QUEUE_LENGTH; i++)
              {
                stopping2DetectorEvent[index] = DETECTOR_NOT_EVENT;
              }
          }     
    }
}


////////////////////////////////////////////////////////////////////////
///
///              calcHalfBodyStats()
///
////////////////////////////////////////////////////////////////////////
void
CTracker::calcHalfBodyStats()
{
  int i, j, k;
  CBlob* halfHumanBlob = new CBlob();
  int top = humanImageBBoxes[index][0][1];
  int bottom = humanImageBBoxes[index][0][3];
  int halfBottom = (bottom + top)/2;

  for (j = top; j < halfBottom; j++)
    for (i = humanImageBBoxes[index][0][0]; i < humanImageBBoxes[index][0][2]; i++)
      {
        int labelValue = blobMap.getPixel(i, j);
        int isHuman = 0;
        for (k = 0; k < numberOfHumanBlobs[index][0]; k++)
          {
            if (labelValue == humanBlobs[index][0][k])
              {
                isHuman = 1;
              }
          }
        if (isHuman)
          {
            halfHumanBlob->addPixel(i, j);
          }
      }

  if (halfHumanBlob->getNumberOfPixels() > 0)
    {
      halfHumanBlob->calculateAll();
      halfHumanBlob->getEigenStuff(&halfHumanImageEigenStuff[index][0]);
      halfHumanBlob->getHuValues(&halfHumanImageHuValues[index][0]);
    }
}

void
CTracker::togglePauseImage()
{
  cerr << "Toggling pause\n";
  pauseImage = 1 - pauseImage;
}

  















