//LinRBF.h
//Chris Bentzel
//This is an abstract class as well...

/***************************************************************************
 * 
 * Copyright 1997  by  the  Massachusetts Institute  of Technology.   All  
 * rights reserved.
 * 
 * Developed  by the Perceptual Computing Section 
 * at the Media Laboratory, MIT, Cambridge, Massachusetts.
 * 
 * Permission to use, copy,  or modify this software and  its documentation
 * for  educational  and  research purposes only and without fee  is hereby
 * granted, provided  that this copyright notice and the original authors's
 * names appear  on all copies and supporting documentation.  If individual
 * files are  separated from  this  distribution directory  structure, this
 * copyright notice must be included.  For any other uses of this software,
 * in original or  modified form, including but not limited to distribution
 * in whole or in  part, specific  prior permission  must be  obtained from
 * MIT.  These programs shall not  be  used, rewritten, or  adapted as  the
 *   basis  of  a commercial  software  or  hardware product  without first
 * obtaining appropriate licenses  from MIT.  MIT. makes no representations
 * about the suitability of this  software for any purpose.  It is provided
 * "as is" without express or implied warranty.
 * 
 **************************************************************************/

#ifndef _LIN_RBF_H
#define _LIN_RBF_H

#include "GenMap.h"

class linRBF : public GenMap
	{
	public: 
  
	//Construct/Destruct
	linRBF();
	~linRBF() {};
  
	//implementation of virtual functions
	M<double> useMap(M<double> inData);
	void teachMap();
	void addData(M<double> inData, M<double> outData);
	void readFile(CString MapFileName);
	void writeFile(CString OutFileName);
	int numExamples() {return h;}
  //rbfunc
  //represents h[funcnumber](x[datanumber])
  virtual M<double> rbfunc(int funcnumber, M<double> inData) = 0;
  void clear();
  virtual void* force(CString typeName);
  
protected:
  
  M<double> W;
  int win, wout, h;
  M<double> X, Xmin, Xmax;
  M<double> Y;
};

#endif //_LIN_RBF_H





